<template>
  <el-container>
    <div class="login">
      <el-card>
        <el-row
          style="
            justify-content: center;
            align-items: center;
            margin: 20px 0 0 0;
          "
        >
          <img src="../assets/logo_v.png" alt="logo" height="120" />
        </el-row>
        <el-row style="justify-content: center; align-items: center">
          <h2 v-if="cur_page==0">登录</h2>
          <h2 v-if="cur_page==1">注册</h2>
          <h2 v-if="cur_page==2">重置密码</h2>
        </el-row>
        <!----------------------------登录表单-------------------------------------->
        <el-form
          class="login-form"
          :model="model"
          :rules="rules"
          ref="form"
          @submit.native.prevent="login"
          v-if="cur_page==0"
        >
          <el-form-item prop="accountname">
            <el-input
              v-model="model.accountname"
              placeholder="用户名或邮箱"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item prop="password">
            <el-input
              v-model="model.password"
              placeholder="密码"
              type="password"
              show-password
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item>
            <el-button
              :loading="loading"
              class="login-button"
              type="primary"
              native-type="submit"
              block
              >登录</el-button
            >
          </el-form-item>
        </el-form>
        <el-row v-if="cur_page==0">
          <el-col :span="8">
              <el-link @click.native="cur_page=1">注册</el-link>
          </el-col>
          <el-col :span="8"></el-col>
          <el-col :span="8" align="right">
              <el-link @click.native="cur_page=2">忘记密码</el-link>
          </el-col>
        </el-row>
        <!----------------------------注册表单-------------------------------------->
        <el-form
          class="login-form"
          :model="model"
          :rules="rules"
          ref="form"
          @submit.native.prevent="addUser"
          v-if="cur_page==1"
        >
          <el-form-item prop="username">
            <el-input
              v-model="model.username"
              placeholder="用户名"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item prop="password1">
            <el-input
              v-model="model.password1"
              placeholder="密码"
              type="password"
              show-password
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item prop="password2">
            <el-input
              v-model="model.password2"
              placeholder="确认密码"
              type="password"
              show-password
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item prop="email"
            ><el-input
              v-model="model.email"
              placeholder="邮箱"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item
            ><el-button
              type="success"
              class="login-button"
              style="margin-top: 0"
              round
              plain
              @click="verify()"
              :disabled="timeStageCounter != '验证邮箱'"
              >{{ timeStageCounter }}</el-button
            >
          </el-form-item>
          <el-form-item prop="verify_code">
            <el-input
              v-model="model.verify_code"
              placeholder="验证码"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item>
            <el-button
              :loading="loading"
              class="login-button"
              type="primary"
              native-type="submit"
              block
              >注册</el-button
            >
          </el-form-item>
        </el-form>
        <el-row v-if="cur_page==1">
            <el-link @click.native="cur_page=0">已有账号？点此登录</el-link>
        </el-row>

        <!----------------------------忘记密码表单-------------------------------------->
        <el-form
          class="login-form"
          :model="model"
          :rules="rules"
          ref="form"
          @submit.native.prevent="resetPassword"
          v-if="cur_page==2"
        >
          <el-form-item prop="f_email"
            ><el-input
              v-model="model.f_email"
              placeholder="邮箱"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item
            ><el-button
              type="success"
              class="login-button"
              style="margin-top: 0"
              round
              plain
              @click="fVerify()"
              :disabled="timeStageCounter != '验证邮箱'"
              >{{ timeStageCounter }}</el-button
            >
          </el-form-item>
          <el-form-item prop="f_verify_code">
            <el-input
              v-model="model.f_verify_code"
              placeholder="验证码"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item prop="f_password1">
            <el-input
              v-model="model.f_password1"
              placeholder="新密码"
              type="password"
              show-password
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item prop="f_password2">
            <el-input
              v-model="model.f_password2"
              placeholder="确认新密码"
              type="password"
              show-password
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item>
            <el-button
              :loading="loading"
              class="login-button"
              type="primary"
              native-type="submit"
              block
              >重置</el-button
            >
          </el-form-item>
        </el-form>
        <el-row v-if="cur_page==2">
            <el-link @click.native="cur_apge=0">想起来了，去登录</el-link>
        </el-row>

      </el-card>
    </div>

  </el-container>
</template>
 
<script>
import { ElMessage } from "element-plus";
export default {
  name: "login",
  data() {
    return {
      model: {
        // 登录相关信息
        accountname: "",
        password: "",
        // 注册相关信息
        username: "",
        password1: "",
        password2: "",
        email: "",
        verify_code: "",
        // 忘记密码相关信息
        f_password1:"",
        f_password2: "",
        f_email: "",
        f_verify_code: "",
      },
      timeStageCounter: "验证邮箱",
      loading: false,
      rules: {
        // 登录相关信息
        accountname: [
          {
            required: true,
            message: "请输入用户名或邮箱",
            trigger: "blur",
          },
        ],
        password: [{ required: true, message: "请输入密码", trigger: "blur" }],
        // 注册相关信息
        username: [
          {
            required: true,
            message: "请输入用户名",
            trigger: "blur",
          },
          {
            pattern: /^[a-zA-Z][a-zA-Z0-9]{2,9}$/,
            message: "用户名由字母开头，可包含字母数字，3-10位",
            trigger: ["change", "blur"],
          },
        ],
        password1: [
          {
            required: true,
            message: "请输入密码",
            trigger: "blur",
          },
          {
            pattern: /^[_a-zA-Z0-9]{6,15}$/,
            message: "密码可包括英文字母、数字和下划线，6-15位",
            trigger: ["change", "blur"],
          },
        ],
        password2: [
          {
            required: true,
            message: "请确认密码",
            trigger: "blur",
          },
          {
            validator: (rule, value, callback) => {
              if (value !== this.model.password1) {
                callback(new Error("两次输入密码不一致"));
              } else {
                callback();
              }
            },
            trigger: ["blur", "change"],
          },
        ],
        email: [
          {
            required: true,
            message: "请输入邮箱",
            trigger: "blur",
          },
          {
            type: "email",
            message: "请填写正确的邮箱",
            trigger: ["blur", "change"],
          },
        ],
        verify_code: [
          {
            required: true,
            message: "请输入验证码",
            trigger: "blur",
          },
        ],
        // 忘记密码相关信息
        f_password1: [
          {
            required: true,
            message: "请输入密码",
            trigger: "blur",
          },
          {
            pattern: /^[_a-zA-Z0-9]{6,15}$/,
            message: "密码可包括英文字母、数字和下划线，6-15位",
            trigger: ["change", "blur"],
          },
        ],
        f_password2: [
          {
            required: true,
            message: "请确认密码",
            trigger: "blur",
          },
          {
            validator: (rule, value, callback) => {
              if (value !== this.model.f_password1) {
                callback(new Error("两次输入密码不一致"));
              } else {
                callback();
              }
            },
            trigger: ["blur", "change"],
          },
        ],
        f_email: [
          {
            required: true,
            message: "请输入邮箱",
            trigger: "blur",
          },
          {
            type: "email",
            message: "请填写正确的邮箱",
            trigger: ["blur", "change"],
          },
        ],
        f_verify_code: [
          {
            required: true,
            message: "请输入验证码",
            trigger: "blur",
          },
        ],
      },
      cur_page:0,   // 0为登录页，1为注册页，2为忘记密码页
    };
  },
  created() {},
  methods: {
    login() {
      this.$refs["form"].validate((isValid) => {
        if (!isValid) {
          ElMessage({
            message: "请检查输入",
            type: "error",
          });
        } else {
          let formData = {
            username: "",
            password: this.model.password,
            email: "",
          };
          if (this.model.accountname.includes("@"))
            formData.email = this.model.accountname;
          else formData.username = this.model.accountname;
          this.axios
            .post("/api/accounts/login/", formData)
            .then((response) => {
              if (response.data.message == "success") {
                ElMessage({
                  message: "登录成功",
                  type: "success",
                });
                this.$router.push("/UserSpace");
              } else {
                ElMessage({
                  message: response.data.data.detail,
                  type: "error",
                });
              }
            })
            .catch(function (error) {
              console.log(error);
            });
        }
      });
    },
    register() {
      this.cur_page=0;
    },
    verify() {
      this.$refs["form"].validateField("email", (isValid) => {
        if (!isValid) {
          ElMessage({
            message: "请输入正确的邮箱",
            type: "error",
          });
        } else {
          this.axios
            .post("/api/accounts/verify/", {
              email: this.model.email,
            })
            .then((response) => {
              if (response.data.message == "failure") {
                ElMessage({
                  message: response.data.data.detail,
                  type: "error",
                });
              } else {
                ElMessage({
                  message: "Coconow已向您的邮箱发送验证码，请查收",
                  type: "success",
                });
                let seconds = 60;
                this.timeStageCounter = `${seconds}秒后重发`;
                let downCounter = setInterval(() => {
                  seconds--;
                  this.timeStageCounter = `${seconds}秒后重发`;
                  if (seconds == 0) {
                    clearInterval(downCounter);
                    this.timeStageCounter = "验证邮箱";
                  }
                }, 1000);
              }
            });
        }
      });
    },
    addUser() {
      this.$refs["form"].validate((isValid) => {
        if (!isValid) {
          ElMessage({
            message: "请检查输入",
            type: "error",
          });
        } else {
          this.axios
            .post("/api/accounts/register/", {
              username: this.model.username,
              password: this.model.password1,
              email: this.model.email,
              verify_code: this.model.verify_code,
            })
            .then((response) => {
              if (response.data.message == "success") {
                ElMessage({
                  message: "注册成功",
                  type: "success",
                });
                this.cur_page=0;
              } else {
                ElMessage({
                  message: response.data.data.detail,
                  type: "error",
                });
              }
            })
            .catch(function (error) {
              console.log(error);
            });
        }
      });
    },
    fVerify() {
      this.$refs["form"].validateField("f_email", (isValid) => {
        if (!isValid) {
          ElMessage({
            message: "请输入正确的邮箱",
            type: "error",
          });
        } else {
          this.axios
            .post("/api/accounts/forgetpassword1/", {
              email: this.model.f_email,
            })
            .then((response) => {
              if (response.data.message == "success") {
                ElMessage({
                  message: "Coconow已向您的邮箱发送验证码，请查收",
                  type: "success",
                });
                let seconds = 60;
                this.timeStageCounter = `${seconds}秒后重发`; // TODO: Mysterious Name 2
                let downCounter = setInterval(() => {
                  seconds--;
                  this.timeStageCounter = `${seconds}秒后重发`;
                  if (seconds == 0) {
                    clearInterval(downCounter);
                    this.timeStageCounter = "验证邮箱";
                  }
                }, 1000);
              } else {
                ElMessage({
                  message: response.data.data.detail,
                  type: "error",
                });
              }
            });
        }
      });
    },
    resetPassword() {
      this.$refs["form"].validate((isValid) => {
        if (!isValid) {
          ElMessage({
            message: "请检查输入",
            type: "error",
          });
        } else {
          this.axios
            .post("/api/accounts/forgetpassword2/", {
              password: this.model.f_password1,
              email: this.model.f_email,
              verify_code: this.model.f_verify_code,
            })
            .then((response) => {
              if (response.data.message == "success") {
                ElMessage({
                  message: "密码已重置",
                  type: "success",
                });
                this.cur_page=0
              } else {
                ElMessage({
                  message: response.data.data.detail,
                  type: "error",
                });
              }
            })
            .catch(function (error) {
              console.log(error);
            });
        }
      });
    },
  },
};
</script>

<style scoped>
.login {
  width: 100%;
  height: 100%;
  flex: 1;
  display: flex;
  justify-content: center;
  align-items: center;
  position: absolute;
}

.login-button {
  width: 100%;
  margin-top: 20px;
}
.login-form {
  width: 250px;
}
.forgot-password {
  margin-top: 10px;
}
</style>
<style lang="scss">
$teal: rgb(0, 124, 137);
.el-button--primary {
  background: $teal;
  border-color: $teal;

  &:hover,
  &.active,
  &:focus {
    background: lighten($teal, 7);
    border-color: lighten($teal, 7);
  }
}
.login .el-input__inner:hover {
  border-color: $teal;
}
.login .el-input__prefix {
  background: rgb(238, 237, 234);
  left: 0;
  height: calc(100% - 2px);
  left: 1px;
  top: 1px;
  border-radius: 3px;
  .el-input__icon {
    width: 30px;
  }
}
.login .el-input input {
  padding-left: 10px;
}
.login .el-card {
  padding-top: 0;
  padding-bottom: 30px;
}
h2 {
  font-family: "Open Sans";
  letter-spacing: 1px;
  font-family: Roboto, sans-serif;
  padding-bottom: 20px;
}
a {
  color: $teal;
  text-decoration: none;
  &:hover,
  &:active,
  &:focus {
    color: lighten($teal, 7);
  }
}
.login .el-card {
  width: 340px;
  display: flex;
  justify-content: center;
}
</style>